﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;
using ESRI.ArcGIS.Carto;
using ESRI.ArcGIS.Geodatabase;
using ESRI.ArcGIS.Geometry;
using BenjaminSchroeter.GeoNames;
using System.Net;
using System.IO;
using System.Xml;
using System.Threading;
using CefSharp;
using CefSharp.WinForms;

namespace mapEdit
{
    public partial class Form1 : Form
    {
        IFeature feature = null;//the feature will be edited.
        IFeatureClass pFcls;
        IWorkspaceEdit pWorkEdit;

        int iFeatureID;//current Feature ID
        int iFeatureNext1;
        int iFeatureNext2;
        int iFeatureNext3;
        int iFeatureNext4;

        Thread tGetXYData;
        Thread tRefreshMap;
        double Y;
        double X;
        int iSelIndex;
        bool IsFirst;//is the first search?
        

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //test

            webBrowser1.Navigate(@"http://localhost:8088/HTMLPage.htm?lat=34.6789435071879&lng=94.0618902446438");
            //Console.WriteLine(this.xtraTabControl1.SelectedTabPageIndex);
            try
            {
                iFeatureID = 0;
                //this.radioButton1.Checked = true;
                this.radioS1.Checked = true;
                this.cmbType.SelectedIndex = 1;
                iSelIndex = this.cmbType.SelectedIndex;
                IsFirst = false;
                this.xtraTabControl1.ShowTabHeader = DevExpress.Utils.DefaultBoolean.False;

                IFeatureLayer pFtLayer = this.axMapControl1.get_Layer(0) as IFeatureLayer;//yxk
                Console.WriteLine(pFtLayer.Name);
                pFcls = pFtLayer.FeatureClass;
                IWorkspace pWorkspace = (this.pFcls as IDataset).Workspace;
                pWorkEdit = pWorkspace as IWorkspaceEdit;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }
        private int GetNextFeature(int iInput)
        {
            int i = 0;
            for (i = iInput + 1; i < 110000; i++)
            {
                try
                {
                    IFeature pTempFeature;
                    pTempFeature = pFcls.GetFeature(i);
                    IArea pArea = (IArea)pTempFeature.Shape;
                    //if (pTempFeature.get_Value(pTempFeature.Fields.FindField("Type")).ToString() == "Lake" && pArea.Area < 0.0000151)
                    if (pTempFeature.get_Value(pTempFeature.Fields.FindField("Elevation")) >= 4700 && pTempFeature.get_Value(pTempFeature.Fields.FindField("InG")) >= 1) // && pArea.Area < 0.0000151)
                    {
                        return i;
                        //break;
                    }
                    if (i > 110000)
                    {
                        MessageBox.Show("No record available...");
                        return 0;
                    }
                }
                catch (Exception ex)
                { Console.WriteLine(ex.Message); }

            }
            return 0;
        }
        private int GetPreFeature(int iInput)
        {
            int i = 0;
            for (i = iInput - 1; i > 1; i--)
            {
                try
                {
                    IFeature pTempFeature;
                    pTempFeature = pFcls.GetFeature(i);
                    if (pTempFeature != null)
                    {
                        return i;
                    }
                }
                catch (Exception ex)
                { Console.WriteLine(ex.Message); }

            }
            return 0;
        }
        //initialize browser
        private void InitWebBrowers()
        {
            IFeature pNextFeature;
            //IEnvelope pNextEnvelope;
            if (IsFirst)
            {

                IFeature pTempFeature;
                pTempFeature = pFcls.GetFeature(iFeatureID);
                if (pTempFeature.get_Value(pTempFeature.Fields.FindField("Type")).ToString().Trim() == "")
                {
                    return;
                }

                int pTempNext = GetNextFeature(iFeatureNext4);
                iFeatureID = iFeatureNext1;
                iFeatureNext1 = iFeatureNext2;
                iFeatureNext2 = iFeatureNext3;
                iFeatureNext3 = iFeatureNext4;
                iFeatureNext4 = pTempNext;

                pNextFeature = pFcls.GetFeature(iFeatureNext4);
                IArea pArea = pNextFeature.Shape as IArea;
                IPoint pPoint = pArea.Centroid;
                double X = pPoint.X;
                double Y = pPoint.Y;
                string strWebsite = null;
                strWebsite = @"http://localhost:8088/HTMLPage.htm?lat=" + Y.ToString() + "&lng=" + X.ToString();
                switch (xtraTabControl1.SelectedTabPageIndex)
                {
                    case 0:
                        this.xtraTabControl1.SelectedTabPageIndex = 1;
                        webBrowser1.Navigate(strWebsite);
                        break;
                    case 1:
                        this.xtraTabControl1.SelectedTabPageIndex = 2;
                        webBrowser2.Navigate(strWebsite);
                        break;
                    case 2:
                        this.xtraTabControl1.SelectedTabPageIndex = 3;
                        webBrowser3.Navigate(strWebsite);
                        break;
                    case 3:
                        this.xtraTabControl1.SelectedTabPageIndex = 4;
                        webBrowser4.Navigate(strWebsite);
                        break;
                    case 4:
                        this.xtraTabControl1.SelectedTabPageIndex = 0;
                        webBrowser5.Navigate(strWebsite);
                        break;
                }
                //Console.WriteLine("It's end...");
            }
            else
            {
                iFeatureID = GetNextFeature(iFeatureID);
                pNextFeature = pFcls.GetFeature(iFeatureID);
                IArea pArea = pNextFeature.Shape as IArea;
                IPoint pPoint = pArea.Centroid;
                X = pPoint.X;
                Y = pPoint.Y;
                string strWebsite = null;
                strWebsite = @"http://localhost:8088/HTMLPage.htm?lat=" + Y.ToString() + "&lng=" + X.ToString();
                webBrowser1.Navigate(strWebsite);
                this.xtraTabControl1.SelectedTabPageIndex = 0;

                iFeatureNext1 = GetNextFeature(iFeatureID);
                pNextFeature = pFcls.GetFeature(iFeatureNext1);
                pArea = pNextFeature.Shape as IArea;
                pPoint = pArea.Centroid;
                X = pPoint.X;
                Y = pPoint.Y;
                strWebsite = null;
                strWebsite = @"http://localhost:8088/HTMLPage.htm?lat=" + Y.ToString() + "&lng=" + X.ToString();
                webBrowser2.Navigate(strWebsite);



                iFeatureNext2 = GetNextFeature(iFeatureNext1);
                pNextFeature = pFcls.GetFeature(iFeatureNext2);
                pArea = pNextFeature.Shape as IArea;
                pPoint = pArea.Centroid;
                X = pPoint.X;
                Y = pPoint.Y;
                strWebsite = null;
                strWebsite = @"http://localhost:8088/HTMLPage.htm?lat=" + Y.ToString() + "&lng=" + X.ToString();
                webBrowser3.Navigate(strWebsite);

                iFeatureNext3 = GetNextFeature(iFeatureNext2);
                pNextFeature = pFcls.GetFeature(iFeatureNext3);
                pArea = pNextFeature.Shape as IArea;
                pPoint = pArea.Centroid;
                X = pPoint.X;
                Y = pPoint.Y;
                strWebsite = null;
                strWebsite = @"http://localhost:8088/HTMLPage.htm?lat=" + Y.ToString() + "&lng=" + X.ToString();
                webBrowser4.Navigate(strWebsite);

                iFeatureNext4 = GetNextFeature(iFeatureNext3);
                pNextFeature = pFcls.GetFeature(iFeatureNext4);
                pArea = pNextFeature.Shape as IArea;
                pPoint = pArea.Centroid;
                X = pPoint.X;
                Y = pPoint.Y;
                strWebsite = null;
                strWebsite = @"http://localhost:8088/HTMLPage.htm?lat=" + Y.ToString() + "&lng=" + X.ToString();
                webBrowser5.Navigate(strWebsite);

                this.IsFirst = true;

            }
        }
        private void simpleButton2_Click(object sender, EventArgs e)
        {
            try
            {
                this.InitWebBrowers();//set browser settings

                this.lstName.Items.Clear();//clear list
                this.axMapControl1.Map.ClearSelection();
                feature = pFcls.GetFeature(iFeatureID);
                IEnvelope pEvp = feature.Extent;

                Double Width = pEvp.Width;
                Double Height = pEvp.Height;

                //pEvp.Expand(-0.5, -0.5, true);
                pEvp.XMin = pEvp.XMin - 0.1 * pEvp.Width;
                pEvp.YMin = pEvp.YMin - 0.1 * pEvp.Height;
                pEvp.XMax = pEvp.XMax + 0.1 * pEvp.Width;
                pEvp.YMax = pEvp.YMax + 0.1 * pEvp.Height;


                this.axMapControl1.ActiveView.Extent = pEvp;

                this.txtName.Text = feature.get_Value(feature.Fields.FindField("Elevation")).ToString();
                if (this.tRefreshMap == null)
                {
                    tRefreshMap = new Thread(new ThreadStart(ForceRefreshMap));
                }
                else
                {
                    tRefreshMap.Abort();
                    tRefreshMap = new Thread(new ThreadStart(ForceRefreshMap));
                }
                tRefreshMap.Start();
                IArea pArea = feature.Shape as IArea;
                IPoint pPoint = pArea.Centroid;
                X = pPoint.X;
                Y = pPoint.Y;
                label8.Text = X.ToString();
                label9.Text = Y.ToString();
                //this.preFID = this.txtFID.Text;
                this.lblPreFID.Text = this.txtFID.Text;
                this.txtFID.Text = feature.OID.ToString();


                //get the geo address
                //this.GetGeoAddress(X, Y);
                //*************************************************************************************
                ////multi threads
                //if (tGetXYData == null)
                //{
                //    tGetXYData = new Thread(new ThreadStart(GetGeoNamesEx));//-----------------------------
                //}
                //else
                //{
                //    tGetXYData.Abort();
                //    tGetXYData = new Thread(new ThreadStart(GetGeoNamesEx));//-----------------------------
                //}
                //tGetXYData.Start();
                //************************************************************************************
                //this.GetGeoNamesEx();

                //if (this.txtLocation.Text == "time out....")
                //{ this.GetGeoAddress(X, Y); }
                int iIndex;
                switch (xtraTabControl1.SelectedTabPageIndex)
                {
                    case 0:
                        iIndex = this.webBrowser1.Url.ToString().LastIndexOf("=");
                        this.txtLocation.Text = this.webBrowser1.Url.ToString().Substring(iIndex + 1, webBrowser1.Url.ToString().Length - iIndex - 1);
                        break;
                    case 1:
                        iIndex = this.webBrowser2.Url.ToString().LastIndexOf("=");
                        this.txtLocation.Text = this.webBrowser2.Url.ToString().Substring(iIndex + 1, webBrowser2.Url.ToString().Length - iIndex - 1);
                        break;
                    case 2:
                        iIndex = this.webBrowser3.Url.ToString().LastIndexOf("=");
                        this.txtLocation.Text = this.webBrowser3.Url.ToString().Substring(iIndex + 1, webBrowser3.Url.ToString().Length - iIndex - 1);
                        break;
                    case 3:
                        iIndex = this.webBrowser4.Url.ToString().LastIndexOf("=");
                        this.txtLocation.Text = this.webBrowser4.Url.ToString().Substring(iIndex + 1, webBrowser4.Url.ToString().Length - iIndex - 1);
                        break;
                    case 4:
                        iIndex = this.webBrowser5.Url.ToString().LastIndexOf("=");
                        this.txtLocation.Text = this.webBrowser5.Url.ToString().Substring(iIndex + 1, webBrowser5.Url.ToString().Length - iIndex - 1);
                        break;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + "--no data any more..");
            }
        }
        private void ForceRefreshMap()
        {
            string str = "";
            Console.WriteLine("map thread started....");
            this.RefreshMap(str);
            //this.axMapControl1.ActiveView.PartialRefresh(esriViewDrawPhase.esriViewGeography, null, null);
        }
        //declare maprefresh delegate
        delegate void RefreshMapDelegate(string str);
        private void RefreshMap(string str)
        {
            if (this.axMapControl1.InvokeRequired)
            {
                RefreshMapDelegate d = new RefreshMapDelegate(RefreshMap);
                //richTextBox1.Invoke(d, "abc");
                this.axMapControl1.Invoke(d, str);
            }
            else
            {
                this.axMapControl1.ActiveView.PartialRefresh(esriViewDrawPhase.esriViewGeography, null, null);
                //this.axMapControl1.ActiveView.Refresh();
            }
        }

        protected string GetElement(XmlElement doc, string name)
        {
            XmlNodeList elements = doc.GetElementsByTagName(name);

            if (elements.Count == 0)
                return "";

            return elements[0].InnerXml;
        }
        private void GetGeoAddress(double X, double Y)
        {
            /* try
             {
                 //get the waterbody name based geonames databae
                 HttpWebRequest request;
                 HttpWebResponse response;
                 StreamReader reader;
                 string xml;
                 request = null;
                 request = (HttpWebRequest)WebRequest.Create(String.Format("http://maps.googleapis.com/maps/api/geocode/json?latlng={0},{1}&sensor=false&num=1", Y.ToString(), X.ToString()));
                 request.Timeout = 5000;
                 response = (HttpWebResponse)request.GetResponse();
                 //response.setHeader("Cache-Control", "no-cache");
                 //response.ContentType="application/text";
                 //response.ContentEncoding = System.Text.Encoding.UTF8;
                 //response.CharacterSet = "utf-8";
                 reader = new StreamReader(response.GetResponseStream(),Encoding.UTF8);
                 xml = reader.ReadToEnd();
                 //response.Close();
                 //JavaScriptSerializer serializer = new JavaScriptSerializer();
                 //object value;
                 //Dictionary<string, object> json = (Dictionary<string, object>)serializer.DeserializeObject(xml);
                 //if (json.TryGetValue("formatted_address", out value))
                 //{
                 //    Console.WriteLine(value.ToString());
                 //}

                 //string address = String.Format("http://maps.googleapis.com/maps/api/geocode/json?latlng={0},{1}&sensor=false&num=1", Y.ToString(), X.ToString());//"http://maps.google.com/maps/api/geocode/json?address=1600+Amphitheatre+Parkway,+Mountain+View,+CA&sensor=false";
                 //var result = new System.Net.WebClient().DownloadString(address);
                 JavaScriptSerializer serializer = new JavaScriptSerializer();
                 GoogleGeoCodeResponse test = JsonConvert.DeserializeObject<GoogleGeoCodeResponse>(xml);

                 if (test.status == "OK")
                 {
                     results[] pRest = test.results;
                     this.txtLocation.Text = pRest[0].formatted_address;
                 }
                 else { this.txtLocation.Text = "time out...."; }
                 //XmlDocument pXML = new XmlDocument();
                 //pXML.LoadXml(xml);
                 //if (pXML.DocumentElement == null)
                 //    return;
                 //XmlNodeList root = null;
               
                 // root = pXML.GetElementsByTagName("result");
                 //if (root.Count == 0)
                 //{
                 //    return;
                 //}
                 ////int i = 0;
                 ////for (i = 0; i < root.Count; i++)
                 ////{
                 //    XmlElement pXmlEl = root[0] as XmlElement;//
                 //    string Name = this.GetElement(pXmlEl, "formatted_address");
                 //    //Console.WriteLine(Name);
                 ////}
                 //    this.txtLocation.Text = Name;
             }
             catch (Exception ex)
             {
                 this.txtLocation.Text ="time out....";
             }*/
        }
        private void GetGeoNamesEx()
        {
            MDBOperation pDbReader = new MDBOperation(@"d:\data.mdb");
            string strSQL = "";
            if (X > 0.0 && X <= 22.5)
            {
                strSQL = "select name,fclass,fcode,sqr((" + Y.ToString() + "-latitude)*(" + Y.ToString() + "-latitude)+(" + X.ToString() + "-longitude)*(" + X.ToString() + "-longitude))" +
               " as distance from waterbodiesP11 where sqr((" + Y.ToString() + "-latitude)*(" + Y.ToString() + "-latitude)+(" + X.ToString() + "-longitude)*(" + X.ToString() + "-longitude))<0.03";
            }
            else if (X > 22.5 && X <= 45.5)
            {
                strSQL = "select name,fclass,fcode,sqr((" + Y.ToString() + "-latitude)*(" + Y.ToString() + "-latitude)+(" + X.ToString() + "-longitude)*(" + X.ToString() + "-longitude))" +
              " as distance from waterbodiesP12 where sqr((" + Y.ToString() + "-latitude)*(" + Y.ToString() + "-latitude)+(" + X.ToString() + "-longitude)*(" + X.ToString() + "-longitude))<0.03";

            }
            else if (X > 45.5 && X <= 105.5)
            {
                strSQL = "select name,fclass,fcode,sqr((" + Y.ToString() + "-latitude)*(" + Y.ToString() + "-latitude)+(" + X.ToString() + "-longitude)*(" + X.ToString() + "-longitude))" +
                " as distance from waterbodiesP13 where sqr((" + Y.ToString() + "-latitude)*(" + Y.ToString() + "-latitude)+(" + X.ToString() + "-longitude)*(" + X.ToString() + "-longitude))<0.03";

            }
            else if (X > 105.5)
            {
                strSQL = "select name,fclass,fcode,sqr((" + Y.ToString() + "-latitude)*(" + Y.ToString() + "-latitude)+(" + X.ToString() + "-longitude)*(" + X.ToString() + "-longitude))" +
              " as distance from waterbodiesP14 where sqr((" + Y.ToString() + "-latitude)*(" + Y.ToString() + "-latitude)+(" + X.ToString() + "-longitude)*(" + X.ToString() + "-longitude))<0.03";
            }
            //Console.WriteLine(DateTime.Now.ToLongTimeString());
            DataTable pDataTable = pDbReader.ImportMDBToDataSetEx(strSQL);
            //pDataTable.DefaultView.Sort = "distance asc";
            //Console.WriteLine(DateTime.Now.ToLongTimeString());
            DataView dv = pDataTable.DefaultView;
            dv.Sort = "distance Asc";
            DataTable dt2 = dv.ToTable();
            int i = 0;
            for (i = 0; i < dt2.Rows.Count; i++)
            {
                //this.cmbName.Items.Add(pDataTable.Rows[i]["name"].ToString());
                this.AppendString(dt2.Rows[i]["name"].ToString());
                //Console.WriteLine(pDataTable.Rows[i]["name"].ToString());
                if (i == 0)
                {
                    this.ChangeDataType(dt2.Rows[i]["fcode"].ToString());
                }
                Console.WriteLine(dt2.Rows[i]["fcode"].ToString());
                //Console.WriteLine(dt2.Rows[i]["distance"].ToString());
            }
            this.AppendString("----");
            //this.cmbName.Items.Add("----");
            //this.cmbName.SelectedIndex = 0;

        }
        private void GetGeoNames()
        {
            try
            {
                //get the geonames based on http request
                HttpWebRequest request;
                HttpWebResponse response;
                StreamReader reader;
                string xml;
                request = null;
                if (radioS1.Checked == true)
                {
                    request = (HttpWebRequest)WebRequest.Create(String.Format("http://ws.geonames.org/findNearby?featureClass=H&radius=3.5&lat={0}&lng={1}", Y.ToString(), X.ToString()));
                }
                else if (radioS2.Checked == true)
                {
                    request = (HttpWebRequest)WebRequest.Create(String.Format("http://services.gisgraphy.com/geoloc/search?lat={0}&lng={1}&radius=3500&from=1&to=10&placetype=lake", Y.ToString(), X.ToString()));
                    //http://services.gisgraphy.com/geoloc/search?lat={0}&lng={1}&radius=2000&from=1&to=10&placetype=lake
                }
                request.Timeout = 9000;
                response = (HttpWebResponse)request.GetResponse();
                reader = new StreamReader(response.GetResponseStream());
                xml = reader.ReadToEnd();
                response.Close();
                XmlDocument pXML = new XmlDocument();
                pXML.LoadXml(xml);
                if (pXML.DocumentElement == null)
                    return;

                XmlNodeList root = null;
                if (this.radioS1.Checked)
                { root = pXML.GetElementsByTagName("geoname"); }
                else if (this.radioS2.Checked)
                { root = pXML.GetElementsByTagName("result"); }
                if (root.Count == 0)
                {
                    this.AppendString("----");
                    return;
                }
                int i = 0;
                for (i = 0; i < root.Count; i++)
                {
                    XmlElement pXmlEl = root[i] as XmlElement;
                    string Name = this.GetElement(pXmlEl, "name");
                    this.AppendString(Name);
                    string Fcode = this.GetElement(pXmlEl, "fcode");//
                    if (this.radioS2.Checked)
                    { Fcode = this.GetElement(pXmlEl, "featureCode"); }
                    Console.WriteLine(Fcode);
                    string strDist = this.GetElement(pXmlEl, "distance");
                    //double dCDist = 0.0;
                    //if (radioS1.Checked)
                    //{ dCDist = 1.0; }
                    //else if (radioS2.Checked)
                    //{ dCDist = 1000; }
                    this.ChangeDataType(Fcode);
                }
                //-----------------------------------------------------------------
                //if (this.radioS2.Checked)
                //{
                //    request = (HttpWebRequest)WebRequest.Create(String.Format("http://services.gisgraphy.com/geoloc/search?lat={0}&lng={1}&radius=2500&from=1&to=10&placetype=dam", Y.ToString(), X.ToString()));
                //    response = (HttpWebResponse)request.GetResponse();
                //    reader = new StreamReader(response.GetResponseStream());
                //    xml = reader.ReadToEnd();
                //    response.Close();
                //    pXML = new XmlDocument();
                //    pXML.LoadXml(xml);
                //    if (pXML.DocumentElement != null)
                //    {
                //        root = pXML.GetElementsByTagName("result");
                //        Console.WriteLine("got dam" + root.Count.ToString());
                //        if (root.Count > 0)
                //        { this.ChangeDataType(""); }//delegate
                //        for (i = 0; i < root.Count; i++)
                //        {
                //            XmlElement pXmlEl = root[i] as XmlElement;
                //            string Name = this.GetElement(pXmlEl, "name");
                //            this.AppendString(Name);
                //        }
                //    }
                //    this.AppendString("----");
                //}
            }
            catch (Exception ex)
            {
                this.AppendString("--");
            }

        }
        //delegate
        delegate void AppendStringDelegate(string str);
        private void AppendString(string str)
        {
            if (this.lstName.InvokeRequired)
            {
                AppendStringDelegate d = new AppendStringDelegate(AppendString);
                //richTextBox1.Invoke(d, "abc");
                this.lstName.Invoke(d, str);
            }
            else
            {
                //this.txtName.Text = str; 

                this.lstName.Items.Add(str);
                this.lstName.SelectedIndex = 0;
            }
        }
        delegate void ChangeDataTypeDelegate(string str);
        private void ChangeDataType(string str)
        {
            if (this.cmbType.InvokeRequired)
            {
                ChangeDataTypeDelegate d = new ChangeDataTypeDelegate(ChangeDataType);
                this.cmbType.Invoke(d, str);
            }
            else
            {
                //this.cmbType.SelectedIndex = 2;
                if (str == "RSV")
                { this.cmbType.SelectedIndex = 2; }
                else if (str == "SEA" || str == "GULF" || str == "BAY" || str == "BAYS" || str == "HBR" || str == "OCN")
                {
                    this.cmbType.SelectedIndex = 3;
                }
                else if (str == "SWMP" || str == "MRSH")
                { this.cmbType.SelectedIndex = 4; }
                else if (str == "LK" || str == "LGN" || str == "PND")
                {
                    this.cmbType.SelectedIndex = 1;
                }
            }
        }
        private void simpleButton1_Click(object sender, EventArgs e)
        {
            if (this.pFcls == null) return;

            if (this.cmbType.SelectedIndex == -1)
            {
                MessageBox.Show("water body type must be selected!");
                return;
            }
            try
            {

                //this.tGetXYData.Abort();//end the thread.
                //if (this.txtName.Text != "----" && this.txtName.Text != "--")//add name of the water body
                //{
                //    string strName = this.txtName.Text;//StringToUniCode.StringToUnicode( this.txtName.Text.Trim());
                //    feature.set_Value(feature.Fields.FindField("name"), strName);//+" "+this.cmbType.SelectedItem.ToString());
                //}
                string strType = this.cmbType.SelectedItem.ToString();
                if (strType == "Normal lake")
                {
                    feature.set_Value(feature.Fields.FindField("type"), 0);
                }
                else if (strType == "Supraglacial lake")
                {
                    feature.set_Value(feature.Fields.FindField("type"), 1);
                }
                else if (strType == "Proglacial lake")
                {
                    feature.set_Value(feature.Fields.FindField("type"), 2);
                }
                else
                {
                    feature.set_Value(feature.Fields.FindField("type"), 3);
                }

                //feature.set_Value(feature.Fields.FindField("type"), this.cmbType.SelectedItem.ToString());

                //update location info
                //if (this.txtLocation.Text != "" && cmbType.SelectedItem.ToString() != "River")
                //{
                //    feature.set_Value(feature.Fields.FindField("location"), this.txtLocation.Text.Trim());
                //    int iStart = this.txtLocation.Text.Trim().LastIndexOf(",");
                //    int iLength = this.txtLocation.Text.Trim().Length;
                //    string strCountry = this.txtLocation.Text.Trim().Substring(iStart + 1, iLength - iStart - 1);
                //    feature.set_Value(feature.Fields.FindField("country"), strCountry.Trim());
                //}
                feature.Store();

                this.txtName.Text = "";//cmbname
                this.cmbType.SelectedIndex = iSelIndex;
                this.txtLocation.Text = "";
                //if (MessageBox.Show("OK!!") == DialogResult.OK)
                //{
                simpleButton2_Click(null, null);
                //}
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }


        }


        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (MessageBox.Show("Are you sure to close the program?", "Question", MessageBoxButtons.OKCancel) != DialogResult.OK)
            {
                e.Cancel = true;
            }
        }


        private void simpleButton4_Click(object sender, EventArgs e)
        {
            if (this.iFeatureID > 1)
            {
                int pID = this.GetPreFeature(iFeatureID);

                iFeatureNext4 = iFeatureNext3;
                iFeatureNext3 = iFeatureNext2;
                iFeatureNext2 = iFeatureNext1;
                iFeatureNext1 = iFeatureID;
                iFeatureID = pID;
                if (this.xtraTabControl1.SelectedTabPageIndex == 0)
                { this.xtraTabControl1.SelectedTabPageIndex = 4; }
                else
                {
                    this.xtraTabControl1.SelectedTabPageIndex = xtraTabControl1.SelectedTabPageIndex - 1;
                }
                try
                {
                    feature = pFcls.GetFeature(iFeatureID);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    return;
                }

                this.axMapControl1.Map.ClearSelection();
                //this.axMapControl1.Map.SelectFeature(this.axMapControl1.get_Layer(0), feature);

                IEnvelope pEvp = feature.Extent;
                this.axMapControl1.ActiveView.Extent = pEvp;
                this.axMapControl1.ActiveView.PartialRefresh(esriViewDrawPhase.esriViewGeography, null, null);

                this.cmbType.Text = feature.get_Value(feature.Fields.FindField("type")).ToString();
                this.txtName.Text = feature.get_Value(feature.Fields.FindField("Elevation")).ToString();//cmbname
                //this.txtLocation.Text = feature.get_Value(feature.Fields.FindField("location")).ToString();

                IArea pArea = feature.Shape as IArea;
                IPoint pPoint = pArea.Centroid;
                Double X = pPoint.X;
                Double Y = pPoint.Y;
                label8.Text = X.ToString();
                label9.Text = Y.ToString();

                Double Width = pEvp.Width;
                Double Height = pEvp.Height;
                this.txtFID.Text = feature.OID.ToString();

                string strWebsite = "";
                strWebsite = @"http://localhost:8088/HTMLPage.htm?lat=" + Y.ToString() + "&lng=" + X.ToString();
                switch (xtraTabControl1.SelectedTabPageIndex)
                {
                    case 0:
                        webBrowser1.Navigate(strWebsite);
                        break;
                    case 1:
                        webBrowser2.Navigate(strWebsite);
                        break;
                    case 2:
                        webBrowser3.Navigate(strWebsite);
                        break;
                    case 3:
                        webBrowser4.Navigate(strWebsite);
                        break;
                    case 4:
                        webBrowser5.Navigate(strWebsite);
                        break;
                }
            }

        }

        private void webBrowser1_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            //int iIndex = this.webBrowser1.Url.ToString().LastIndexOf("=");
            //this.txtLocation.Text = this.webBrowser1.Url.ToString().Substring(iIndex + 1, webBrowser1.Url.ToString().Length - iIndex - 1);
        }

        private void Form1_ResizeEnd(object sender, EventArgs e)
        {
            if (this.splitContainer1.Size.Width > 380)
            {
                this.splitContainer1.SplitterDistance = this.splitContainer1.Size.Width - 374;
            }
        }

        private void Form1_Resize(object sender, EventArgs e)
        {

            if (this.splitContainer1.Size.Width > 380)
            {
                this.splitContainer1.SplitterDistance = this.splitContainer1.Size.Width - 374;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FrmLetter pfrm = new FrmLetter();
            if (pfrm.ShowDialog() == DialogResult.OK)
            {
                this.txtName.Text = this.txtName.Text + pfrm.Letter;
            }
            this.txtName.Focus();
            txtName.Select(txtName.Text.Length, 0);
        }
        #region "char control"
        private void button2_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button2.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button3.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button5.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button4.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button9.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button8.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button7.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button6.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button15_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button15.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }

        private void button14_Click(object sender, EventArgs e)
        {
            //this.txtName.Text = this.txtName.Text + button14.Text;
            //this.txtName.Focus();
            //txtName.Select(txtName.Text.Length, 0);
        }
        #endregion

        private void btnClear_Click(object sender, EventArgs e)
        {
            this.txtName.Text = "";
        }

        private void button16_Click(object sender, EventArgs e)
        {
            //int iIndex = this.webBrowser1.Url.ToString().LastIndexOf("=");
            //this.txtLocation.Text = this.webBrowser1.Url.ToString().Substring(iIndex + 1, webBrowser1.Url.ToString().Length - iIndex - 1);
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            this.iFeatureID = int.Parse(this.txtFID.Text.Trim());
            this.simpleButton4_Click(null, null);
            IsFirst = false;
        }

        private void webBrowser2_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            //    int iIndex = this.webBrowser2.Url.ToString().LastIndexOf("=");
            //    this.txtLocation.Text = this.webBrowser2.Url.ToString().Substring(iIndex + 1, webBrowser2.Url.ToString().Length - iIndex - 1);

        }

        private void cmbName_ValueMemberChanged(object sender, EventArgs e)
        {
            //Console.WriteLine("changed");
        }

        private void button11_Click(object sender, EventArgs e)
        {
            this.iSelIndex = this.cmbType.SelectedIndex;
        }

        private void webBrowser1_Navigated_1(object sender, WebBrowserNavigatedEventArgs e)
        {
            Console.WriteLine("OK......");
            Console.WriteLine(webBrowser1.Url.ToString());
            if (xtraTabControl1.SelectedTabPageIndex == 0)
            {
                int iIndex = this.webBrowser1.Url.ToString().LastIndexOf("=");
                this.txtLocation.Text = this.webBrowser1.Url.ToString().Substring(iIndex + 1, webBrowser1.Url.ToString().Length - iIndex - 1);
            }
        }

        private void webBrowser2_Navigated_1(object sender, WebBrowserNavigatedEventArgs e)
        {
            //Console.WriteLine("OK......");
            if (xtraTabControl1.SelectedTabPageIndex == 1)
            {
                int iIndex = this.webBrowser2.Url.ToString().LastIndexOf("=");
                this.txtLocation.Text = this.webBrowser2.Url.ToString().Substring(iIndex + 1, webBrowser2.Url.ToString().Length - iIndex - 1);
            }
        }

        private void webBrowser3_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            //Console.WriteLine("OK......");
            if (xtraTabControl1.SelectedTabPageIndex == 2)
            {
                int iIndex = this.webBrowser3.Url.ToString().LastIndexOf("=");
                this.txtLocation.Text = this.webBrowser3.Url.ToString().Substring(iIndex + 1, webBrowser3.Url.ToString().Length - iIndex - 1);
            }
        }

        private void webBrowser4_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            //Console.WriteLine("OK......");
            if (xtraTabControl1.SelectedTabPageIndex == 3)
            {
                int iIndex = this.webBrowser4.Url.ToString().LastIndexOf("=");
                this.txtLocation.Text = this.webBrowser4.Url.ToString().Substring(iIndex + 1, webBrowser4.Url.ToString().Length - iIndex - 1);
            }
        }

        private void webBrowser5_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            //Console.WriteLine("OK......");
            if (xtraTabControl1.SelectedTabPageIndex == 4)
            {
                int iIndex = this.webBrowser5.Url.ToString().LastIndexOf("=");
                this.txtLocation.Text = this.webBrowser5.Url.ToString().Substring(iIndex + 1, webBrowser5.Url.ToString().Length - iIndex - 1);
            }
        }

        private void axMapControl1_OnViewRefreshed(object sender, ESRI.ArcGIS.Controls.IMapControlEvents2_OnViewRefreshedEvent e)
        {
            //Console.WriteLine("map OK......");
        }

        private void axMapControl1_OnAfterDraw(object sender, ESRI.ArcGIS.Controls.IMapControlEvents2_OnAfterDrawEvent e)
        {
            Console.WriteLine("map OK......");
        }

        private void cmbName_KeyUp(object sender, KeyEventArgs e)
        {
            //if (e.KeyValue ==20)
            //{
            //    this.simpleButton1_Click(null, null);
            //    this.Focus();
            //} 
        }

        private void cmbName_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.Focus();
        }

        private void lstName_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.txtName.Text = this.lstName.SelectedItem.ToString();
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            string strWebsite = "";
            switch (xtraTabControl1.SelectedTabPageIndex)
            {
                case 0:
                    strWebsite = webBrowser1.Url.ToString();
                    strWebsite = strWebsite.Replace("8082", "8081");
                    strWebsite = strWebsite.Replace("8083", "8081");
                    webBrowser1.Navigate(strWebsite);
                    break;
                case 1:
                    strWebsite = webBrowser2.Url.ToString();
                    strWebsite = strWebsite.Replace("8082", "8081");
                    strWebsite = strWebsite.Replace("8083", "8081");
                    webBrowser2.Navigate(strWebsite);
                    break;
                case 2:
                    strWebsite = webBrowser3.Url.ToString();
                    strWebsite = strWebsite.Replace("8082", "8081");
                    strWebsite = strWebsite.Replace("8083", "8081");
                    webBrowser3.Navigate(strWebsite);
                    break;
                case 3:
                    strWebsite = webBrowser4.Url.ToString();
                    strWebsite = strWebsite.Replace("8082", "8081");
                    strWebsite = strWebsite.Replace("8083", "8081");
                    webBrowser4.Navigate(strWebsite);
                    break;
                case 4:
                    strWebsite = webBrowser5.Url.ToString();
                    strWebsite = strWebsite.Replace("8082", "8081");
                    strWebsite = strWebsite.Replace("8083", "8081");
                    webBrowser5.Navigate(strWebsite);
                    break;
            }
        }

        private void button3_Click_1(object sender, EventArgs e)
        {
            string strWebsite = "";
            //string strReplace="";
            switch (xtraTabControl1.SelectedTabPageIndex)
            {
                case 0:
                    strWebsite = webBrowser1.Url.ToString();
                    strWebsite = strWebsite.Replace("8080", "8082");
                    strWebsite = strWebsite.Replace("8081", "8082");
                    strWebsite = strWebsite.Replace("8083", "8082");
                    webBrowser1.Navigate(strWebsite);
                    break;
                case 1:
                    strWebsite = webBrowser2.Url.ToString();
                    strWebsite = strWebsite.Replace("8080", "8082");
                    strWebsite = strWebsite.Replace("8081", "8082");
                    strWebsite = strWebsite.Replace("8083", "8082");
                    webBrowser2.Navigate(strWebsite);
                    break;
                case 2:
                    strWebsite = webBrowser3.Url.ToString();
                    strWebsite = strWebsite.Replace("8080", "8082");
                    strWebsite = strWebsite.Replace("8081", "8082");
                    strWebsite = strWebsite.Replace("8083", "8082");
                    webBrowser3.Navigate(strWebsite);
                    break;
                case 3:
                    strWebsite = webBrowser4.Url.ToString();
                    strWebsite = strWebsite.Replace("8080", "8082");
                    strWebsite = strWebsite.Replace("8081", "8082");
                    strWebsite = strWebsite.Replace("8083", "8082");
                    webBrowser4.Navigate(strWebsite);
                    break;
                case 4:
                    strWebsite = webBrowser5.Url.ToString();
                    strWebsite = strWebsite.Replace("8080", "8082");
                    strWebsite = strWebsite.Replace("8081", "8082");
                    strWebsite = strWebsite.Replace("8083", "8082");
                    webBrowser5.Navigate(strWebsite);
                    break;
            }
        }

        private void button4_Click_1(object sender, EventArgs e)
        {
            string strWebsite = "";
            //string strReplace="";
            switch (xtraTabControl1.SelectedTabPageIndex)
            {
                case 0:
                    strWebsite = webBrowser1.Url.ToString();
                    strWebsite = strWebsite.Replace("8088", "8083");
                    strWebsite = strWebsite.Replace("8082", "8083");
                    strWebsite = strWebsite.Replace("8081", "8083");
                    webBrowser1.Navigate(strWebsite);
                    break;
                case 1:
                    strWebsite = webBrowser2.Url.ToString();
                    strWebsite = strWebsite.Replace("8088", "8083");
                    strWebsite = strWebsite.Replace("8082", "8083");
                    strWebsite = strWebsite.Replace("8081", "8083");
                    webBrowser2.Navigate(strWebsite);
                    break;
                case 2:
                    strWebsite = webBrowser3.Url.ToString();
                    strWebsite = strWebsite.Replace("8088", "8083");
                    strWebsite = strWebsite.Replace("8082", "8083");
                    strWebsite = strWebsite.Replace("8081", "8083");
                    webBrowser3.Navigate(strWebsite);
                    break;
                case 3:
                    strWebsite = webBrowser4.Url.ToString();
                    strWebsite = strWebsite.Replace("8088", "8083");
                    strWebsite = strWebsite.Replace("8082", "8083");
                    strWebsite = strWebsite.Replace("8081", "8083");
                    webBrowser4.Navigate(strWebsite);
                    break;
                case 4:
                    strWebsite = webBrowser5.Url.ToString();
                    strWebsite = strWebsite.Replace("8088", "8083");
                    strWebsite = strWebsite.Replace("8082", "8083");
                    strWebsite = strWebsite.Replace("8081", "8083");
                    webBrowser5.Navigate(strWebsite);
                    break;
            }
        }

        private void txtName_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 20)
            {
                this.simpleButton1_Click(null, null);
                this.Focus();
            }
        }
    }
}
